/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package md.orange.MDBtest;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;

/**
 *
 * @author aanischevici
 */
@MessageDriven(mappedName = "jms/testQueue", activationConfig = {
    @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
    @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue")
})
public class testMDB implements MessageListener {
    @Resource(mappedName = "jms/testQueue2")
    private Queue testQueue2;
    @Resource(mappedName = "jms/testQueue2Factory")
    private ConnectionFactory testQueue2Factory;
    
    public testMDB() {
    }
    
    @Override
    public void onMessage(Message message) {
        TextMessage tmm = (TextMessage) message;
        try {
            String str = tmm.getText();
            System.out.println("MDB1 > " + str);
            sendJMSMessageToTestQueue2("MDB1+" + str);
        } catch (JMSException ex) {
            Logger.getLogger(testMDB.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private Message createJMSMessageForjmsTestQueue2(Session session, String messageData) throws JMSException {
        // TODO create and populate message to send
        TextMessage tm = session.createTextMessage();
        tm.setText(messageData);
        return tm;
    }

    private void sendJMSMessageToTestQueue2(String messageData) throws JMSException {
        Connection connection = null;
        Session session = null;
        try {
            connection = testQueue2Factory.createConnection();
            session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
            MessageProducer messageProducer = session.createProducer(testQueue2);
            messageProducer.send(createJMSMessageForjmsTestQueue2(session, messageData));
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (JMSException e) {
                    Logger.getLogger(this.getClass().getName()).log(Level.WARNING, "Cannot close session", e);
                }
            }
            if (connection != null) {
                connection.close();
            }
        }
    }
}
