/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package md.orange.MDBtest;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jws.WebService;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.ejb.Stateless;

/**
 *
 * @author aanischevici
 */
@WebService(serviceName = "testWS")
@Stateless()
public class testWS {
    @Resource(mappedName = "jms/testQueue")
    private Queue testQueue;
    @Resource(mappedName = "jms/testQueueFactory")
    private ConnectionFactory testQueueFactory;

    /** This is a sample web service operation */
    @WebMethod(operationName = "hello")
    public String hello(@WebParam(name = "name") String txt) {
        System.out.println("WS > " + txt);
        try {
            sendJMSMessageToTestQueue(txt);
        } catch (JMSException ex) {
            Logger.getLogger(testWS.class.getName()).log(Level.SEVERE, null, ex);
        }
        return "Hello " + txt + " !";
    }

    private Message createJMSMessageForjmsTestQueue(Session session, String messageData) throws JMSException {
        // TODO create and populate message to send
        TextMessage tm = session.createTextMessage();
        tm.setText(messageData);
        return tm;
    }

    private void sendJMSMessageToTestQueue(String messageData) throws JMSException {
        Connection connection = null;
        Session session = null;
        try {
            connection = testQueueFactory.createConnection();
            session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
            MessageProducer messageProducer = session.createProducer(testQueue);
            messageProducer.send(createJMSMessageForjmsTestQueue(session, messageData));
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (JMSException e) {
                    Logger.getLogger(this.getClass().getName()).log(Level.WARNING, "Cannot close session", e);
                }
            }
            if (connection != null) {
                connection.close();
            }
        }
    }
}
